/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * eml_mtimes_helper.c
 *
 * Code generation for function 'eml_mtimes_helper'
 *
 */

/* Include files */
#include "eml_mtimes_helper.h"
#include "MC_loop_parallel_data.h"
#include "MC_loop_parallel_emxutil.h"
#include "MC_loop_parallel_types.h"
#include "rt_nonfinite.h"

/* Variable Definitions */
static emlrtRTEInfo f_emlrtRTEI =
    {
        134,                   /* lineNo */
        23,                    /* colNo */
        "dynamic_size_checks", /* fName */
        "C:\\Program "
        "Files\\MATLAB\\R2021b\\toolbox\\eml\\lib\\matlab\\ops\\eml_mtimes_"
        "helper.m" /* pName */
};

static emlrtRTEInfo g_emlrtRTEI =
    {
        129,                   /* lineNo */
        23,                    /* colNo */
        "dynamic_size_checks", /* fName */
        "C:\\Program "
        "Files\\MATLAB\\R2021b\\toolbox\\eml\\lib\\matlab\\ops\\eml_mtimes_"
        "helper.m" /* pName */
};

/* Function Definitions */
void c_binary_expand_op(const emlrtStack *sp, emxArray_real_T *y, real_T alpha,
                        const emxArray_real_T *b_I, int32_T tt,
                        const emxArray_real_T *X)
{
  const real_T *I_data;
  const real_T *X_data;
  real_T *y_data;
  int32_T i;
  int32_T i1;
  int32_T loop_ub;
  int32_T stride_0_2;
  int32_T stride_1_2;
  X_data = X->data;
  I_data = b_I->data;
  i = b_I->size[2];
  i1 = X->size[2];
  loop_ub = y->size[0] * y->size[1] * y->size[2];
  y->size[0] = 1;
  y->size[1] = 1;
  if (i1 == 1) {
    y->size[2] = i;
  } else {
    y->size[2] = i1;
  }
  emxEnsureCapacity_real_T(sp, y, loop_ub, &w_emlrtRTEI);
  y_data = y->data;
  stride_0_2 = (i != 1);
  stride_1_2 = (i1 != 1);
  if (i1 == 1) {
    loop_ub = i;
  } else {
    loop_ub = i1;
  }
  for (i = 0; i < loop_ub; i++) {
    y_data[i] = alpha * (I_data[tt + b_I->size[0] * (i * stride_0_2)] -
                         X_data[(tt + X->size[0] * 3) +
                                X->size[0] * X->size[1] * (i * stride_1_2)]);
  }
}

void d_binary_expand_op(const emlrtStack *sp, emxArray_real_T *r1,
                        real_T iota_L, const emxArray_real_T *b,
                        const emxArray_real_T *P, int32_T tt, real_T r,
                        real_T fore_disc)
{
  const real_T *P_data;
  const real_T *b_data;
  real_T *b_r;
  int32_T i;
  int32_T loop_ub;
  int32_T stride_0_1;
  int32_T stride_1_1;
  P_data = P->data;
  b_data = b->data;
  i = P->size[1];
  stride_0_1 = r1->size[0] * r1->size[1];
  r1->size[0] = 1;
  if (i == 1) {
    r1->size[1] = b->size[1];
  } else {
    r1->size[1] = i;
  }
  emxEnsureCapacity_real_T(sp, r1, stride_0_1, &xb_emlrtRTEI);
  b_r = r1->data;
  stride_0_1 = (b->size[1] != 1);
  stride_1_1 = (i != 1);
  if (i == 1) {
    loop_ub = b->size[1];
  } else {
    loop_ub = i;
  }
  for (i = 0; i < loop_ub; i++) {
    b_r[i] = iota_L * b_data[i * stride_0_1] *
             P_data[tt + P->size[0] * (i * stride_1_1)] / (r + 1.0) * fore_disc;
  }
}

void dynamic_size_checks(const emlrtStack *sp, int32_T a_size,
                         const emxArray_real_T *b, int32_T innerDimA,
                         int32_T innerDimB)
{
  if (innerDimA != innerDimB) {
    if ((a_size == 1) || ((b->size[0] == 1) && (b->size[1] == 1))) {
      emlrtErrorWithMessageIdR2018a(
          sp, &g_emlrtRTEI, "Coder:toolbox:mtimes_noDynamicScalarExpansion",
          "Coder:toolbox:mtimes_noDynamicScalarExpansion", 0);
    } else {
      emlrtErrorWithMessageIdR2018a(sp, &f_emlrtRTEI, "MATLAB:innerdim",
                                    "MATLAB:innerdim", 0);
    }
  }
}

void i_binary_expand_op(const emlrtStack *sp, emxArray_real_T *r1,
                        real_T iota_L, const emxArray_real_T *b,
                        const emxArray_real_T *P, real_T nPeriods, real_T r,
                        real_T fore_disc)
{
  const real_T *P_data;
  const real_T *b_data;
  real_T *b_r;
  int32_T i;
  int32_T loop_ub;
  int32_T stride_0_1;
  int32_T stride_1_1;
  P_data = P->data;
  b_data = b->data;
  i = P->size[1];
  stride_0_1 = r1->size[0] * r1->size[1];
  r1->size[0] = 1;
  if (i == 1) {
    r1->size[1] = b->size[1];
  } else {
    r1->size[1] = i;
  }
  emxEnsureCapacity_real_T(sp, r1, stride_0_1, &kb_emlrtRTEI);
  b_r = r1->data;
  stride_0_1 = (b->size[1] != 1);
  stride_1_1 = (i != 1);
  if (i == 1) {
    loop_ub = b->size[1];
  } else {
    loop_ub = i;
  }
  for (i = 0; i < loop_ub; i++) {
    b_r[i] = iota_L * b_data[i * stride_0_1] *
             P_data[(int32_T)nPeriods + P->size[0] * (i * stride_1_1)] /
             (r + 1.0) * fore_disc;
  }
}

/* End of code generation (eml_mtimes_helper.c) */
