/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * normcdf.c
 *
 * Code generation for function 'normcdf'
 *
 */

/* Include files */
#include "normcdf.h"
#include "MC_loop_parallel_emxutil.h"
#include "MC_loop_parallel_types.h"
#include "rt_nonfinite.h"
#include "mwmathutil.h"
#include <math.h>

/* Variable Definitions */
static emlrtBCInfo wb_emlrtBCI = {
    -1,        /* iFirst */
    -1,        /* iLast */
    49,        /* lineNo */
    32,        /* colNo */
    "",        /* aName */
    "normcdf", /* fName */
    "C:\\Program Files\\MATLAB\\R2021b\\toolbox\\stats\\eml\\normcdf.m", /* pName
                                                                          */
    0 /* checkKind */
};

static emlrtBCInfo xb_emlrtBCI = {
    -1,        /* iFirst */
    -1,        /* iLast */
    93,        /* lineNo */
    11,        /* colNo */
    "",        /* aName */
    "normcdf", /* fName */
    "C:\\Program Files\\MATLAB\\R2021b\\toolbox\\stats\\eml\\normcdf.m", /* pName
                                                                          */
    0 /* checkKind */
};

static emlrtBCInfo yb_emlrtBCI = {
    -1,        /* iFirst */
    -1,        /* iLast */
    54,        /* lineNo */
    15,        /* colNo */
    "",        /* aName */
    "normcdf", /* fName */
    "C:\\Program Files\\MATLAB\\R2021b\\toolbox\\stats\\eml\\normcdf.m", /* pName
                                                                          */
    0 /* checkKind */
};

static emlrtBCInfo ac_emlrtBCI = {
    -1,        /* iFirst */
    -1,        /* iLast */
    79,        /* lineNo */
    11,        /* colNo */
    "",        /* aName */
    "normcdf", /* fName */
    "C:\\Program Files\\MATLAB\\R2021b\\toolbox\\stats\\eml\\normcdf.m", /* pName
                                                                          */
    0 /* checkKind */
};

static emlrtRTEInfo mc_emlrtRTEI = {
    43,        /* lineNo */
    5,         /* colNo */
    "normcdf", /* fName */
    "C:\\Program Files\\MATLAB\\R2021b\\toolbox\\stats\\eml\\normcdf.m" /* pName
                                                                         */
};

/* Function Definitions */
void normcdf(const emlrtStack *sp, const emxArray_real_T *x, real_T varargin_1,
             real_T varargin_2, emxArray_real_T *p)
{
  const real_T *x_data;
  real_T R;
  real_T S;
  real_T absx;
  real_T b_x;
  real_T s;
  real_T *p_data;
  int32_T b;
  int32_T eint;
  int32_T i;
  int32_T k;
  x_data = x->data;
  i = p->size[0] * p->size[1];
  p->size[0] = 1;
  p->size[1] = (uint16_T)x->size[1];
  emxEnsureCapacity_real_T(sp, p, i, &mc_emlrtRTEI);
  p_data = p->data;
  i = (uint16_T)x->size[1];
  for (k = 0; k < i; k++) {
    if (k + 1 > x->size[1]) {
      emlrtDynamicBoundsCheckR2012b(k + 1, 1, x->size[1], &wb_emlrtBCI,
                                    (emlrtCTX)sp);
    }
    if (varargin_2 == 0.0) {
      if (k + 1 > p->size[1]) {
        emlrtDynamicBoundsCheckR2012b(k + 1, 1, p->size[1], &yb_emlrtBCI,
                                      (emlrtCTX)sp);
      }
      p_data[k] = !(x_data[k] < varargin_1);
    } else if (varargin_2 > 0.0) {
      b_x = -((x_data[k] - varargin_1) / varargin_2) / 1.4142135623730951;
      /* ========================== COPYRIGHT NOTICE
       * ============================ */
      /*  The algorithms for calculating ERF(X) and ERFC(X) are derived */
      /*  from FDLIBM, which has the following notice: */
      /*                                                                          */
      /*  Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved. */
      /*                                                                          */
      /*  Developed at SunSoft, a Sun Microsystems, Inc. business. */
      /*  Permission to use, copy, modify, and distribute this */
      /*  software is freely granted, provided that this notice */
      /*  is preserved. */
      /* =============================    END ================================
       */
      absx = muDoubleScalarAbs(b_x);
      if (muDoubleScalarIsNaN(b_x)) {
        s = b_x;
      } else if (muDoubleScalarIsInf(b_x)) {
        if (b_x < 0.0) {
          s = 2.0;
        } else {
          s = 0.0;
        }
      } else if (absx < 0.84375) {
        if (absx < 1.3877787807814457E-17) {
          s = 1.0 - b_x;
        } else {
          s = b_x * b_x;
          s = (s * (s * (s * (s * -2.3763016656650163E-5 +
                              -0.0057702702964894416) +
                         -0.02848174957559851) +
                    -0.3250421072470015) +
               0.12837916709551256) /
              (s * (s * (s * (s * (s * -3.9602282787753681E-6 +
                                   0.00013249473800432164) +
                              0.0050813062818757656) +
                         0.0650222499887673) +
                    0.39791722395915535) +
               1.0);
          if (b_x < 0.25) {
            s = 1.0 - (b_x + b_x * s);
          } else {
            s = 0.5 - (b_x * s + (b_x - 0.5));
          }
        }
      } else if (absx < 1.25) {
        S = (absx - 1.0) *
                ((absx - 1.0) *
                     ((absx - 1.0) *
                          ((absx - 1.0) *
                               ((absx - 1.0) *
                                    ((absx - 1.0) * -0.0021663755948687908 +
                                     0.035478304325618236) +
                                -0.11089469428239668) +
                           0.31834661990116175) +
                      -0.37220787603570132) +
                 0.41485611868374833) +
            -0.0023621185607526594;
        s = (absx - 1.0) *
                ((absx - 1.0) *
                     ((absx - 1.0) *
                          ((absx - 1.0) *
                               ((absx - 1.0) *
                                    ((absx - 1.0) * 0.011984499846799107 +
                                     0.013637083912029051) +
                                0.12617121980876164) +
                           0.071828654414196266) +
                      0.540397917702171) +
                 0.10642088040084423) +
            1.0;
        if (b_x >= 0.0) {
          s = 0.15493708848953247 - S / s;
        } else {
          s = (S / s + 0.84506291151046753) + 1.0;
        }
      } else if (b_x < -6.0) {
        s = 2.0;
      } else if (b_x >= 28.0) {
        s = 0.0;
      } else {
        s = 1.0 / (absx * absx);
        if (absx < 2.8571414947509766) {
          R = s * (s * (s * (s * (s * (s * (s * -9.8143293441691455 +
                                            -81.2874355063066) +
                                       -184.60509290671104) +
                                  -162.39666946257347) +
                             -62.375332450326006) +
                        -10.558626225323291) +
                   -0.69385857270718176) +
              -0.0098649440348471482;
          S = s * (s * (s * (s * (s * (s * (s * (s * -0.0604244152148581 +
                                                 6.5702497703192817) +
                                            108.63500554177944) +
                                       429.00814002756783) +
                                  645.38727173326788) +
                             434.56587747522923) +
                        137.65775414351904) +
                   19.651271667439257) +
              1.0;
        } else {
          R = s * (s * (s * (s * (s * (s * -483.5191916086514 +
                                       -1025.0951316110772) +
                                  -637.56644336838963) +
                             -160.63638485582192) +
                        -17.757954917754752) +
                   -0.799283237680523) +
              -0.0098649429247001;
          S = s * (s * (s * (s * (s * (s * (s * -22.440952446585818 +
                                            474.52854120695537) +
                                       2553.0504064331644) +
                                  3199.8582195085955) +
                             1536.729586084437) +
                        325.79251299657392) +
                   30.338060743482458) +
              1.0;
        }
        if ((!muDoubleScalarIsInf(absx)) && (!muDoubleScalarIsNaN(absx))) {
          s = frexp(absx, &eint);
          b = eint;
        } else {
          s = absx;
          b = 0;
        }
        s = muDoubleScalarFloor(s * 2.097152E+6) / 2.097152E+6 *
            muDoubleScalarPower(2.0, b);
        s = muDoubleScalarExp(-s * s - 0.5625) *
            muDoubleScalarExp((s - absx) * (s + absx) + R / S) / absx;
        if (b_x < 0.0) {
          s = 2.0 - s;
        }
      }
      if (k + 1 > p->size[1]) {
        emlrtDynamicBoundsCheckR2012b(k + 1, 1, p->size[1], &ac_emlrtBCI,
                                      (emlrtCTX)sp);
      }
      p_data[k] = 0.5 * s;
    } else {
      if (k + 1 > p->size[1]) {
        emlrtDynamicBoundsCheckR2012b(k + 1, 1, p->size[1], &xb_emlrtBCI,
                                      (emlrtCTX)sp);
      }
      p_data[k] = rtNaN;
    }
  }
}

/* End of code generation (normcdf.c) */
