function [S,Sr,n,domain,D_grid,m_grid,H_grid,Ibar_grid]...
    = grid_construct(w,chebsize)
%grid_construct Constructs a full or reduced sprase grid for the
%approximation of the equilibrium price and investment functions

        num_vars=4;
        map_lb=[0.725 .002 1.00 .006 -1*ones(1,chebsize)];
        map_ub=[1.000 .04 1.50 .007 ones(1,chebsize)];
        domain=[map_lb;map_ub];
        [S,Sr,~] = create_sparsegrid(num_vars,chebsize,w,map_lb,map_ub);
        n=Sr.size;

        
        D_grid=Sr.knots(1,:);
        m_grid=Sr.knots(2,:);
        H_grid=Sr.knots(3,:);
        Ibar_grid=Sr.knots(4,:);
    
    
end

