function [P,I,Fore_rate,W,m_phi,mu_true,mu_rational,flags,loan_dist_cheb,ubound_cheb,lbound_cheb,Hdot,V,H,D]=run_model_smm(mu0,mubar,sigma_mu,theta,phi,nu,k,kappa,chi,iota_L,iota_R,rho,eta,aa,bb,gamma_elas,nTrials_mc)
    % Runs model for SMM
    
     %Exogenously calibrated parameters
    load exog_params;
    
    save('passed_params','chi','gamma_elas','eta','gam','mu0','mubar','sigma_mu','theta',...
        'nu','k','kappa','phi','iota_L','iota_R','aa','bb','rho','LTV_load_flag','nTrials_mc');

    %% Set up paramaters

    clear;
    addpath(genpath(pwd));
    run gen_parameters_passparams;
    
    %% Solve global equilibrium
    display('Solve Global')
    %nTrials=int16(100); 
    nTrials_mc=int16(nTrials_mc);%Number of trials for Monte-Carlo
    T=30; %Years
    ff=365; %Step-size
    tol=1e-3; %Stopping criteria
    max_its=50; %Max number of iterations
    w=3; %Level of the Smolyak grid
    approx_flag='linear'; %Use linear approximation ('linear') of polynomial interpolation ('global')
    [W,bP,bI,bW] = solve_global(T,ff,nTrials_mc,approx_flag,tol,max_its,w);
    clear T ff

    %% Determine initial loan balance distribution
    X_vec=[D0 mubar H0 Ii 1];
    W=X_vec*bW;
    c=(V0-W)/H0^(1/eta);
    
    [P0,I0,flag] = Solve_Eq_Price_BGP(V0,H0,N0,gH,c,eta,chi,xm,gamma_elas,Ii,W,fore_rate_BGP,1,10,options);

    M_dist=@(M) H0*LTV_BGP(M/P0)/P0;
    u_bound=u_mult*P0;
    l_bound=l_mult*P0; %Support of mortgage balance distribution
    u_bound_integral=2.5*P0;

    F = iota_L*integral(@(M) M_dist(M).*J(M./P0),l_bound,u_bound_integral);

    [P0test,I0test,flag_init] = Solve_Eq_Price_Impulse(V0,H0,N0,gH,c,eta,chi,xm,gamma_elas,Ii,W,F,1,P0,options);
    save params
    
    %% Solve impulse response function
    T=25; %Years
    ff=52; %Step-size
    [X,V,P,I,Ibar,a,W,Fore_rate,mu_true,mu_rational,flags] = simulate_impulse_new(T,ff,W,bW);

    %Collect results

    D=X(:,1);
    m_phi=X(:,2);
    H=X(:,3);
    H_pre = ones(52,1);
    H_pre(52) = H0-H0*Ii/52;
    for(t=51:-1:1)
        H_pre(t) = H_pre(t+1)-H0*Ii/52;
    end 
    Hdot = H - [H_pre;H(1:end-52)];

    P(end,:)=P(end-1,:);
    I(end,:)=I(end-1,:);
    H(end,:)=H(end-1,:);
    V=mean(V,2);
    P=mean(P,2);
    I=mean(I,2);

    
    % Loan balance dist every year
    annual = [1:52:T*52+1];
    loan_dist_cheb = a(:,annual);
    ubound_cheb = u_bound;
    lbound_cheb = l_bound;
end