function [P,I,Fore_rate,W,m_phi,mu_true,mu_rational,flags,loan_dist_cheb,ubound_cheb,lbound_cheb,Hdot]=run_model_smm_nopoints(mu0,mubar,sigma_mu,theta,phi,nu,k,kappa,chi,iota_L,iota_R,rho,eta,aa,bb,gamma_elas)
    % Runs model for SMM
    
    %Exogenously calibrated parameters
    load exog_params;
    
    save('passed_params','chi','gamma_elas','eta','gam','mu0','mubar','sigma_mu','theta',...
        'nu','k','kappa','phi','iota_L','iota_R','aa','bb','rho','LTV_load_flag');

    %% Set up paramaters

    clear;
    addpath(genpath(pwd));
    run gen_parameters_passparams;
    
   
    
    %% Solve global equilibrium
    bW = zeros(5,1);
    W=0;
    
    %% Solve impulse response function
    %nTrials=100; %Number of trials for impulse response
    T=25; %Years
    ff=52; %Step-size
    [X,V,P,I,Ibar,a,W,Fore_rate,mu_true,mu_rational,flags] = simulate_impulse_new(T,ff,W,bW);

    %Collect results

    D=X(:,1);
    m_phi=X(:,2);
    H=X(:,3);
    H_pre = ones(52,1);
    H_pre(52) = H0-H0*Ii/52;
    for(t=51:-1:1)
        H_pre(t) = H_pre(t+1)-H0*Ii/52;
    end 
    Hdot = H - [H_pre;H(1:end-52)];

    P(end,:)=P(end-1,:);
    I(end,:)=I(end-1,:);
    V=mean(V,2);
    P=mean(P,2);
    I=mean(I,2);

    
    % Loan balance dist every year
    annual = [1:52:T*52+1];
    loan_dist_cheb = a(:,annual);
    ubound_cheb = u_bound;
    lbound_cheb = l_bound;
end
