function [P,I,Fore_rate,W,m_phi,mu_true,mu_rational,flags,loan_dist_cheb,ubound_cheb,lbound_cheb,Hdot,R10,Ibar,H,a]=run_model_smm_nopoints_rents(mu0,mubar,sigma_mu,theta,phi,nu,k,kappa,chi,iota_L,iota_R,rho,eta,aa,bb,gamma_elas,cost_flag)
    % Runs model for SMM
    
    %Exogenously calibrated parameters
    load exog_params;
    
    save('passed_params','chi','gamma_elas','eta','gam','mu0','mubar','sigma_mu','theta',...
        'nu','k','kappa','phi','iota_L','iota_R','aa','bb','rho','LTV_load_flag','cost_flag');

    %% Set up paramaters

    clear;
    addpath(genpath(pwd));
    run gen_parameters_passparams;
    
   
    
    %% Solve global equilibrium
    bW = zeros(5,1);
    bP1 = zeros(5,1);
    bP10 = zeros(5,1);
    W=0;
    
    %% Solve impulse response function
    %nTrials=100; %Number of trials for impulse response
    T=25; %Years
    ff=52; %Step-size
    [X,V,P,P1,P10,I,Ibar,a,W,F,Fore_rate,mu_true,mu_rational,flags,L,U,PP,M_nodes] = simulate_impulse_forecast(T,ff,W,bW,bP1,bP10);

    %Collect results

    D=X(:,1);
    m_phi=X(:,2);
    H=X(:,3);
    H_pre = ones(52,1);
    H_pre(52) = H0-H0*Ii/52;
    for(t=51:-1:1)
        H_pre(t) = H_pre(t+1)-H0*Ii/52;
    end 
    Hdot = H - [H_pre;H(1:end-52)];
    P(end,:)=P(end-1,:);
    I(end,:)=I(end-1,:);
    V=mean(V,2);
    P=mean(P,2);
    I=mean(I,2);

    
    % Loan balance dist every year
    annual = [1:52:T*52+1];
    loan_dist_cheb = a(:,annual);
    ubound_cheb = u_bound;
    lbound_cheb = l_bound;

    X_eq=X;
    P_eq=P;
    I_eq=I;
    F_eq=F;
    a_eq=a;
    Ibar_eq=Ibar;

    %% Solve for price forecasts and rents

%     Tf=11; %Simulation length for price beliefs
%     [~,R10,~,~,~] = priceBeliefsCalc(X_eq,I_eq,Ibar_eq,a_eq,F_eq,P_eq,L,U,PP,M_nodes,ff,bW,...
%                            mubar,gamma_elas,alpha_Ibar,sigma_D,iota_L,iota_R,u_bound_integral,...
%                            theta,sigma_mu,sigma_m,N0,gH,c,eta,chi,xm,l_bound,u_bound,rho,chebsize,J,LTV_dist,gam,Tf,cost_flag);

    % Compute beliefs
    Tf=30;
    [R1,R10,P1,P10,Pf] = priceBeliefsCalcFull(X_eq,I_eq,Ibar_eq,a_eq,F_eq,P_eq,L,U,PP,M_nodes,ff,bW,...
                           mubar,gamma_elas,alpha_Ibar,sigma_D,iota_L,iota_R,u_bound_integral,...
                           theta,sigma_mu,sigma_m,N0,gH,c,eta,chi,xm,l_bound,u_bound,rho,chebsize,J,LTV_dist,gam,Tf,cost_flag);
    % Target maintanance costs
    PR_Target = 13;
    delta_sol=fsolve( @(delta) computeRentsNew(m_phi,P,Pf,D,rho,mubar,theta,sigma_mu,sigma_m,LTV,ff,T,Tf,delta,PR_Target),3);
    % Compute Rents
    [~,Rent_mp,Price_Rent] = computeRentsNew(m_phi,P,Pf,D,rho,mubar,theta,sigma_mu,sigma_m,LTV,ff,T,Tf,delta_sol,PR_Target);
    
end
