function [P,P_pf,W_pf,I,Fore_rate,W,m_phi,mu_true,mu_rational,flags,loan_dist_cheb,ubound_cheb,Hdot]=run_model_smm_pf(mu0,mubar,sigma_mu,theta,phi,nu,k,kappa,chi,iota_L,iota_R,rho,eta,aa,bb,gamma_elas,fore_disc,cost_flag)
    % Runs model for SMM
    
    %Exogenously calibrated parameters
    load exog_params;
    
    save('passed_params','chi','gamma_elas','eta','gam','mu0','mubar','sigma_mu','theta',...
        'nu','k','kappa','phi','iota_L','iota_R','aa','bb','rho','LTV_load_flag','cost_flag');

    %% Set up paramaters

    clear;
    addpath(genpath(pwd));
    run gen_parameters_passparams;
    
   
    
    %% Solve global equilibrium
    bW = zeros(5,1);
    W=0;
    
    %% Solve impulse response function
    %nTrials=100; %Number of trials for impulse response
    T=25; %Years
    ff=52; %Step-size
    bP1 = zeros(5,1);
    bP10 = zeros(5,1);
    [X,V,P,P1,P10,I,Ibar,a,W,F,Fore_rate,mu_true,mu_rational,flags,L,U,PP,M_nodes] = simulate_impulse_forecast(T,ff,W,bW,bP1,bP10);

    %Collect results

    D=X(:,1);
    m_phi=X(:,2);
    H=X(:,3);
    H_pre = ones(52,1);
    H_pre(52) = H0-H0*Ii/52;
    for(t=51:-1:1)
        H_pre(t) = H_pre(t+1)-H0*Ii/52;
    end 
    Hdot = H - [H_pre;H(1:end-52)];

    P(end,:)=P(end-1,:);
    I(end,:)=I(end-1,:);
    V=mean(V,2);
    P=mean(P,2);
    I=mean(I,2);

    
    % Loan balance dist every year
    annual = [1:52:T*52+1];
    loan_dist_cheb = a(:,annual);
    ubound_cheb = u_bound;
    
    Time = [0:1/52:T];
    fore_discount=fore_disc;
    P_pf=P;
    P_pf_old=P_pf;
    dist=1;
    tol=1e-3; %Stopping criteria
   
    i=1;
    fore_discount=.645;
    tune=0.5;
    
tic
while dist>tol
    i
    dist
    W_pf = calc_points_pf(P_pf,ff,rho,iota_L,iota_R,gam,gpf,aa,bb,LTV,fore_discount);
    [X_pf,V_pf,P_pf_new] = simulate_impulse_pf_new(T,ff,W_pf,bW,bP1,bP10);
    P_pf_new(end,:)=P_pf_new(end-1,:);
    P_pf=P_pf_old+tune*(P_pf_new-P_pf_old);
    dist=norm(P_pf-P_pf_old);
    P_pf_old=P_pf;
    i=i+1;
end
toc
    

    
    
    
    
end
