function [X,V,P,P1,P10,I,Ibar,a,W,F,Fore_rate,mu_true,mu_rational,flags,L,U,PP,M_nodes] = simulate_impulse_forecast(T,ff,W,bW,bP1,bP10)
%UNTITLED8 Summary of this function goes here
%   Detailed explanation goes here

close all;
load params
gamma=gamma_elas;
alpha=alpha_Ibar;
u_bound_int=u_bound_integral;
mu=mu_g;
sigma=sigma_D;
iota=iota_L+iota_R;

dt=1/ff; %Simulation stepsize
nPeriods=T/dt; %Number of simulation periods

%Initial Loan Distribution
[V_cheb,Vd_cheb,a_init,M_nodes] = cheb_create(chebsize,l_bound,u_bound,M_dist,tol_adj);
% V_cheb_inv=inv(V_cheb);
[L,U,PP]=lu(V_cheb);
func_approx=chebfun(a_init,[l_bound,u_bound],'coeffs');
M_vec=linspace(l_bound+tol_adj,u_bound-tol_adj,100);
plot(M_vec,M_dist(M_vec),M_vec,func_approx(M_vec));
legend('True','Approx')


%options = optimoptions('fsolve','SpecifyObjectiveGradient',true);
% [P0,I0] = Solve_Eq_Price_Inv(V0,H0,N0,gN,c,eta,chi,xm,gamma,Ii,0,iota,1,10,options);

%% Defime functions for simulation 
% %X(1) is the dividend
% %X(2)-X(6) are the beliefs
% %X(7) is population growth
% %X(8) is tau_e
% 
% tau=1/sigma;
% m = @(X) (X(2)+X(3))*mu(2)+(X(4)+X(5))*mu(3)+(X(6)+(1-sum(X(2:6))))*mu(1);
% m_e = @(X) X(2)*mu_ef(2)+X(3)*mu_et(2)+X(4)*mu_ef(3)+X(5)*mu_et(3)+...
%         X(6)*mu_ef(1)+(1-sum(X(2:6)))*mu_et(1);
% 
% %F is the drift rate matrix    
% F = @(t,X) [mu(2)*X(1); ...
%     phi*(f(3)-X(2))+tau^2*X(2)*(mu(2)-m(X))*(mu(2)-m(X))+X(7)^2*X(2)*(mu_ef(2)-m_e(X))*(mu_et(2)-m_e(X)); ... 
%     phi*(f(4)-X(3))+tau^2*X(3)*(mu(2)-m(X))*(mu(2)-m(X))+X(7)^2*X(3)*(mu_et(2)-m_e(X))*(mu_et(2)-m_e(X)); ...
%     phi*(f(5)-X(4))+tau^2*X(4)*(mu(3)-m(X))*(mu(2)-m(X))+X(7)^2*X(4)*(mu_ef(3)-m_e(X))*(mu_et(2)-m_e(X)); ... 
%     phi*(f(6)-X(5))+tau^2*X(5)*(mu(3)-m(X))*(mu(2)-m(X))+X(7)^2*X(5)*(mu_et(3)-m_e(X))*(mu_et(2)-m_e(X)); ...
%     phi*(f(1)-X(6))+tau^2*X(6)*(mu(1)-m(X))*(mu(2)-m(X))+X(7)^2*X(6)*(mu_ef(1)-m_e(X))*(mu_et(2)-m_e(X)); ...
%     -tau_e_decay*X(7)];
% 
% %G is the volatility matrix
% G = @(t,X) [sigma*X(1) 0; ...
%     tau*X(2)*(mu(2)-m(X)) X(7)*X(2)*(mu_ef(2)-m_e(X)); ...
%     tau*X(3)*(mu(2)-m(X)) X(7)*X(3)*(mu_et(2)-m_e(X)); ...
%     tau*X(4)*(mu(3)-m(X)) X(7)*X(4)*(mu_ef(3)-m_e(X)); ...
%     tau*X(5)*(mu(3)-m(X)) X(7)*X(5)*(mu_et(3)-m_e(X)); ...
%     tau*X(6)*(mu(1)-m(X)) X(7)*X(6)*(mu_ef(1)-m_e(X)); ...
%     0 0]; 

%% Initialize arrays

%Solve for MC beliefs
% obj=sde(F,G,'StartState',[D0;pi_init(3);pi_init(4);pi_init(5);pi_init(6);pi_init(1);tau_e]);
% rng('default'); 
% [X_MC,~,~]=simulate(obj,nPeriods,'DeltaTime',dt,...
%             'nTrials',nTrials,'Antithetic',true,...
%             'Processes',@(t,X) [abs(X(1));min(max(X(2),0),1);min(max(X(3),0),1);...
%             min(max(X(4),0),1);min(max(X(5),0),1);min(max(X(6),0),1);abs(X(7))]);
% X_MC=mean(X_MC,3);

TT=0:1/ff:T;

X=zeros(nPeriods+1,3);
V=zeros(nPeriods+1,1);

%Mean dividend growth rate
mu_true=mubar+(mu0-mubar)*exp(-theta*TT);
mu_rational=mubar+(mu0-mubar)*exp(-theta*TT)-(mu0-mubar)*exp(-(kappa+theta)*TT);

%Mean path of dividends
X(:,1) = D0*exp(mubar*TT+...
        1/theta*(1-exp(-theta*TT))*(mu0-mubar)+...
        sigma_mu^2/2/theta^2*TT-3*sigma_mu^2/4/theta^3+...
        sigma_mu^2/4/theta^3*(4*exp(-theta*TT)-exp(-2*theta*TT)));
%Mean distorted beliefs
% X(:,2) = mubar+(mu0-mubar)*exp(-theta*TT)-(mu0-mubar)*exp(-(kappa+theta)*TT)+...
%     phi*kappa/(nu-(kappa+theta))*(mu0-mubar)*(exp(-(kappa+theta)*TT)-exp(-nu*TT));
X(:,2) = mubar+(mu0-mubar)*exp(-theta*TT)-(mu0-mubar)*exp(-(kappa+theta)*TT)+...
    phi*kappa/(nu-(kappa+theta))*(mu0-mubar)*(exp(-(kappa+theta)*TT)-...
    exp((nu-(kappa+theta))*((TT-k>0).*(TT-k))-nu*TT)); %Implement max(T-k,0) as (T-k>0).*(T-k)

V = PV(X(:,2),rho,mubar,theta,sigma_mu,sigma_m,X(:,1));

P=zeros(nPeriods+1,1);
P_init=zeros(nPeriods+1,1);
P1=zeros(nPeriods+1,1);
P10=zeros(nPeriods+1,1);
I=zeros(nPeriods+1,1);
Ibar=zeros(nPeriods+1,1);
W=zeros(nPeriods+1,1);
Fore_rate=zeros(nPeriods+1,1);
F=zeros(nPeriods+1,1);
flags=zeros(nPeriods+1,1);
Change=zeros(chebsize+1,nPeriods+1);
Add=zeros(chebsize+1,nPeriods+1);
a=zeros(chebsize+1,nPeriods+1);

X(1,3)=H0;
I(1)=I0;
Ibar(1)=I0;
F(1)=fore_rate_BGP*H0;
W(1)=[D0;mubar;H0;I0;1]'*bW;
P1(1)=[D0;mubar;H0;I0;1]'*bP1;
P10(1)=[D0;mubar;H0;I0;1]'*bP10;
P_init(1)=P0;

a(:,1)=a_init;
M_pdf=chebfun(a(:,1),[l_bound,u_bound],'coeffs');
M_diff=diff(M_pdf);
def_func=@(P) iota_L*integral(@(M) M_pdf(M).*J(M./P),l_bound,u_bound_int);
def_deriv=@(P) iota_L*integral(@(M) -M_pdf(M).*Jd(M./P).*M/(P.^2),l_bound,u_bound_int);
% JJ=zeros(chebsize+1,1);
% for j=1:chebsize+1
%    JJ(j)=default_func(M_nodes(j));
% end
% aint=V_cheb\JJ;
% M_def=chebfun(aint,[l_bound,u_bound],'coeffs');
% M_diff=diff(M_def); 


%Z=zeros(nPeriods,nBrowns,nTrials);
% [P0,I0,fore_test,fval,flag_init] = Solve_Eq_Price_Inv2(V0,H0,N0,gN,c,eta,chi,xm,gamma,Ii,0,def_func,def_deriv,1,V0,options);
% if flag_init ~= 1
%     [P0,I0,fore_test,fval,flag_init] = Solve_Eq_Price_Inv2(V0,H0,N0,gN,c,eta,chi,xm,gamma,Ii,0,def_func,def_deriv,1,V0/10,options);
% end
% P_init_W=P0;
% [P0,I0,fore_test,fval,flag_W] = Solve_Eq_Price_Inv2(V0,H0,N0,gN,c,eta,chi,xm,gamma,Ii,W(1),def_func,def_deriv,1,P_init_W,options);
% P_init(1)=P0;

options = optimoptions('fsolve','SpecifyObjectiveGradient',true,'Display','off');

%% Simulate economy
% for t=2:730
for t=2:nPeriods+1
       
       %Solve for equilibrium price and investment
       [P(t-1),I(t-1),flags(t-1)]...
           =Solve_Eq_Price_Impulse(V(t-1),X(t-1,3),N0,gH,c,eta,chi,xm,gamma,Ibar(t-1),W(t-1),F(t-1),1,P_init(t-1),cost_flag,options);
       P_init(t)=P(t-1);
       
       %Update housing stock
       X(t,3)=X(t-1,3)+I(t-1)*X(t-1,3)*dt;
       
       %Update investment moving average
       Ibar(t) = (1-alpha)*Ibar(t-1)+alpha*I(t-1);
        
       %Determine equilibrium points and price forecasts
       W(t)=[X(t,:) Ibar(t) 1]*bW;
       P1(t)=[X(t,:) Ibar(t) 1]*bP1;
       P10(t)=[X(t,:) Ibar(t) 1]*bP10;
       
       %Update foreclosures for period t and determine foreclosure rate
       F(t)= iota_L*integral(@(M) M_pdf(M).*J(M./P(t-1)),l_bound,u_bound_int);
       Fore_rate(t-1)=F(t)/X(t-1,3);
       
       %Update loan balance distribution
       Change_vec=gam*(M_pdf(M_nodes)+M_nodes.*M_diff(M_nodes))...
              +(I(t-1)*X(t-1,3)+F(t-1))*LTV_dist(M_nodes/P(t-1))/P(t-1)...
              -iota*M_pdf(M_nodes)+(iota*X(t-1,3)-F(t))*LTV_dist(M_nodes/P(t-1))/P(t-1);

       Change(:,t)=Change_vec;
       Change(1,t)=0;
       Change(end,t)=0;
          
       Add(:,t)=U\(L\(PP*Change(:,t)*dt));
       a(:,t)=a(:,t-1)+Add(:,t);
       
       M_pdf=chebfun(a(:,t),[l_bound,u_bound],'coeffs');
       M_diff=diff(M_pdf);
       
      
      
        
end

end

