globa dq_root = "/Volumes/Samsung_T5/DataQuick/Cleaned"
global save_root = "/Users/Adam/Dropbox/Research/House Prices Growth Misperception (CRG)/DQ"

tempfile tempsave tempf 

clear
local first = 1

foreach state in AK AL AR AZ CA CO CT DC DE FL GA HI IA ID IL IN KS KY LA MA MD  ME MI MN MO MS MT  NC ND NE NH NJ NM NV NY OH ///
		OK OR PA RI SC SD TN  TX UT VA VT WA WI WV WY {
	di "State: `state'"
	
	qui cd "$dq_root/History-`state'"
	qui fs *
	foreach f in `r(files)' {
		local county = substr("`f'",strpos("`f'","-")+1,strpos("`f'",".") - strpos("`f'","-") - 1)
		local county = substr("`county'",4,.)
		
		if strpos("`county''","-extras") == 0  & substr("`f'",1,1) ~= "."  {
			if (strpos("`county'","19") == 0 & strpos("`county'","20") == 0) | strpos("`county'","2013") ~= 0 {
				if strpos("`county'","2013") ~= 0 {
					local county = substr("`county'",1,strpos("`county'","2013")-2)
				}
		di "County: `state' `county'"
		clear
		* For LA OC and SD we need to append files
		* So things don't get big we do the drops before appending
		if "`county'"=="los angeles" | ("`state'"=="CA"&"`county'"=="orange") | "`county'"=="san diego" | "`county'" == "alameda" ///
		| "`county'" == "contra costa" | "`county'" == "santa clara" | "`county'" == "maricopa" | "`county'" == "cook" ///
		| "`county'" == "broward" | "`county'" == "miami_dade" | ("`county'" == "orange" & "`state'" == "FL") | "`county'" == "palm beach" | ("`county'" == "clark" & "`state'" == "NV")  ///
		| "`county'" == "san bernardino" | "`county'" == "riverside" | "`county'" == "king" | "`county'" == "sacramento"  ///
		| ("`county'" == "middlesex" & "`state'" == "MA") | ("`county'" == "harris" & "`state'" == "TX") { 
			if "`state'" == "FL" | "`state'" == "IL" | "`state'" == "TX" {
				local year1 = 1997
			}	
			else {
				local year1 = 1988
			}	
			forvalues yr = `year1'/2013 {
				clear
				use sr_property_id mm_fips_state_code mm_fips_muni_code use_code_std sr_tran_type distress_indicator poss_correction close_repeat_sale group_sale partial_sale partial_consideration transfer sr_val_trans sr_date_trans sa_census_tract origination_loan origination_ltv foreclosure_process_not_sale split_property using "$dq_root/History-`state'/History-`state'-`county'_`yr'.dta"
				if `yr'>`year1' {
					append using "`tempsave'"
				}
				save "`tempsave'", replace
			}
		}	
		* For others only one file
		else {
			di "$dq_root/History-`state'/History-`state'-`county'.dta"
			use sr_property_id mm_fips_state_code mm_fips_muni_code use_code_std sr_tran_type distress_indicator poss_correction close_repeat_sale group_sale partial_sale partial_consideration transfer sr_val_trans sr_date_trans sa_census_tract origination_loan origination_ltv foreclosure_process_not_sale split_property using  "$dq_root/History-`state'/History-`state'-`county'.dta"
		}
		
		// Simple Drops
		keep if use_code_std <= 2 // Condos and single family only
		keep if sr_tran_type == 1 // Drop mortgage refinancing keeping only sales
		drop if distress_indicator ~= . | foreclosure_process_not_sale == 1 // Drop distressed or foreclsoure process
		drop if group_sale | split_property | partial_sale | partial_consideration  // Drop group sales, splits, partial sales, partial considerations
		drop if transfer == 1 // Drop transfers
		drop if sr_property_id == . | sr_property_id == 0 // Drop missing property IDs
		drop if year(sr_date_transfer) < 1988 | year(sr_date_transfer) > 2013 | sr_date_transfer == . // Drop implausible dates
		drop if sr_val_trans < 10000 // Drop if less than $10,000
		drop if poss_correction // Drop what appear to be corrections
		drop if close_repeat_sale // Drop if a repeat sale within 30 days
		drop if origination_ltv > 2 // Drop implausibly high LTV
		
		// Drop what we don't need, rename, and save
		keep sr_property_id mm_fips_state_code mm_fips_muni_code sr_val_trans sr_date_trans sa_census_tract 
		ren sa_census_tract census_tract
		ren mm_fips_state_code fips_st
		ren mm_fips_muni_code fips_co
		save `tempf', replace
		
		// Load assesor in assessor
		use sa_property_id sa_val_assd_imprv sa_imprv_pct sa_lotsize sa_sqft sa_nbr_rms sa_nbr_bath sa_nbr_bed sa_yr_blt* bad_bed bad_rooms bad_lotsize bad_bath bad_sqft bad_age  using "/Volumes/Samsung_T5/DataQuick/Cleaned/Assessor-`state'/Assessor-`state'-`county'.dta", clear
		ren sa_property_id sr_property_id
			
		* Windsorize distribution of variables
		winsor sa_nbr_bath, p(.01) gen(bath)
		winsor sa_nbr_bedrms, p(.01) gen(bed)
		winsor sa_nbr_rms, p(.01) gen(rooms)
		winsor sa_sqft, p(.01) gen(sqft)
		winsor sa_lotsize, p(.01) gen(lotsize)
		replace bed = . if bad_bed == 1
		replace bath = . if bad_bath == 1
		replace sqft = . if bad_sqft == 1
		replace sa_yr_blt = . if bad_age == 1
		replace lotsize = . if bad_lotsize == 1
		replace rooms = . if bad_rooms == 1
		drop sa_nbr_bath sa_nbr_bedrms sa_nbr_rms sa_sqft sa_lotsize bad*
		
		* Sqft and lotsize in logs
		replace sqft = log(sqft)
		replace lotsize = log(lotsize)
		
		// Merge assessor and history
		merge 1:m sr_property_id using `tempf'
		drop if _m == 1
		drop _m
		
		if _N > 0 {

			* Drop with significant physical change - if transaction is prior to year built
			drop if sa_yr_blt > year(sr_date_transfer) & sa_yr_blt ~= .
			drop if sa_yr_blt_eff > year(sr_date_transfer) & sa_yr_blt_eff ~= .
			
			// Drop if unimproved land or if improvement is < 5% of value.
			qui sum sa_val_assd_imprv
			if `r(mean)' > 10000 {
				drop if sa_val_assd_imprv == 0
			}
			
			qui sum sa_imprv_pct
			if `r(mean)' > 5 {
				drop if sa_imprv_pct < 5
			}
			drop sa_imprv_pct sa_val_assd_imprv	sa_yr_blt*
			
			// Gen price and quarter
			gen lprice = log(sr_val_transfer)
			gen quarter = qofd(sr_date_transfer)
			format quarter %tq
			gen year = yofd(sr_date_transfer)
			drop sr_date_transfer sr_val_transfer
			compress
			
			if "`first'" == "1" {
				local first = 0
			}
			else {
				append using "$save_root/dq_for_regression.dta"
			}
			save "$save_root/dq_for_regression.dta", replace
			}
		}
	}
	}
}

// Regression
reghdfe lprice, absorb(sr_property_id i.census_tract#i.fips_st#i.fips_co#i.quarter) res(resid)

sum resid, d
di (`r(p75)' - `r(p25)') / (invnormal(.75) - invnormal(.25))
sum resid if year < 2006, d 
di (`r(p75)' - `r(p25)') / (invnormal(.75) - invnormal(.25))

