function [bP,bI,K,R2] = ConstructApprox(P0,I0,Xgrid,S,Sr,domain,flag)
%ConstructApprox Constructs best linear approximation of price and
%investment functions

switch flag
    case 'linear'
        bP=(Xgrid'*Xgrid)\(Xgrid'*P0');
        bI=(Xgrid'*Xgrid)\(Xgrid'*I0');
        K=[];
        Phat=Xgrid*bP;
        R2=1-sum((P0'-Phat).^2)/sum((P0'-mean(P0)).^2);
        
    otherwise
        [b,K] = convert_to_modal(S,Sr,[P0;I0],domain,'chebyshev');
        bP=b(:,1);
        bI=b(:,2);
        
end
end

