function [W,W_mat] = MC_loop_noparallel(bP,bI,I0,P0,Xgrid,T,dt,alpha,aa,bb,iota_L,iota_R,sigma,...
    theta,mubar,K,r,LTV,n,nTrials,Z,fore_disc) %#codegen
%UNTITLED7 Summary of this function goes here
%   Detailed explanation goes here
sqdt=sqrt(dt);
nPeriods=T/dt; %Number of simulation periods

nVars=size(Xgrid,2);
WW=zeros(nTrials,n);
W_mat=zeros(nTrials,n);
M_init=LTV*P0;


for i=1:nTrials
    X=zeros(nPeriods+1,nVars,n);

    P=zeros(nPeriods+1,n);
    E=zeros(nPeriods,n);
    I=zeros(nPeriods+1,1,n);
    M=zeros(nPeriods+1,n);
    
    X(1,:,:)=Xgrid';

    I(1,1,:)=I0';
    P(1,:)=P0';
    M(1,:)=LTV*P(1,:);
    Pay=(r*LTV*P(1,:))/(1-1/(1+r)^nPeriods);
    
    for tt=2:nPeriods+1
        t=tt-1;
       
    
        F = permute([X(t,2,:).*X(t,1,:); ...
            theta*(mubar-X(t,2,:));...
            I(t,1,:).*X(t,3,:); ...
            alpha*(I(t,1,:)-X(t,4,:));zeros(1,1,n)],[2 1 3]);
        
         G1 =   permute([sigma*X(t,1,:,:); ...
                K*ones(1,1,n); ...
                zeros(1,1,n); ...
                zeros(1,1,n);zeros(1,1,n)],[2 1 3]);

%         G2 =    permute([zeros(1,1,n); ...
%                 tau_e*X(t,2,:,:).*(mu_ef(2)-m_e); ...
%                 tau_e*X(t,3,:,:).*(mu_et(2)-m_e); ...
%                 tau_e*X(t,4,:,:).*(mu_ef(3)-m_e); ...
%                 tau_e*X(t,5,:,:).*(mu_et(3)-m_e); ...
%                 tau_e*X(t,6,:,:).*(mu_ef(1)-m_e); ...
%                 zeros(1,1,n); ...
%                 zeros(1,1,n);zeros(1,1,n)],[2 1 3]);
    
        X(tt,:,:) = X(t,:,:)+F*dt... 
        + G1.*Z(t,1,i)*sqdt; 
        M(tt,:)=Pay(1,:)/r*(1-1/(1+r)^(nPeriods-(tt-1)));
        XX=reshape(X(tt,:,:,:),nVars,n);
        P(tt,:)=bP'*XX;
        I(tt,1,:)=bI'*XX; 
    end
    
    %Use backward induction to compute the bond value at each simulation run
    
%         E(nPeriods,:)=(1-iota_L*normcdf((1+r)*M(nPeriods,:)./P(nPeriods+1,:),aa,bb))*Pay(1,:)/(1+r)...
%                     +iota_L*normcdf((1+r)*M(nPeriods,:)./P(nPeriods+1,:),aa,bb).*P(nPeriods+1,:)/(1+r)*fore_disc;
%                 
%     for tt=nPeriods-1:-1:1
%         E(tt,:)= (1-iota_L*normcdf((1+r)*M(tt,:)./P(tt+1,:),aa,bb))*(Pay(1,:)+E(tt+1,:))/(1+r)...
%                     +iota_L*normcdf((1+r)*M(tt,:)./P(tt+1,:),aa,bb).*P(tt+1,:)/(1+r)*fore_disc;
%          
%     end

    E(nPeriods,:)=(1-iota_L-iota_R)*Pay(1,:)/(1+r)...
                    +(iota_R+iota_L*(1-normcdf((1+r)*M(nPeriods,:)./P(nPeriods+1,:),aa,bb))).*M(nPeriods,:)...
                    +iota_L*normcdf((1+r)*M(nPeriods,:)./P(nPeriods+1,:),aa,bb).*P(nPeriods+1,:)/(1+r)*fore_disc;
    
    for tt=nPeriods-1:-1:1
       E(tt,:)= (1-iota_L-iota_R)*(Pay(1,:)+E(tt+1,:))/(1+r)...
                    +(iota_R+iota_L*(1-normcdf((1+r)*M(tt,:)./P(tt+1,:),aa,bb))).*M(tt,:)...
                    +iota_L*normcdf((1+r)*M(tt,:)./P(tt+1,:),aa,bb).*P(tt+1,:)/(1+r)*fore_disc;
         
    end

    WW(i,:)=E(1,:);
    W_mat(i,:)=M_init-E(1,:);
end

%Average bond value across simulation runs and determine mortgage points

W=M_init-mean(WW,1);


    
end

