/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * sumMatrixIncludeNaN.c
 *
 * Code generation for function 'sumMatrixIncludeNaN'
 *
 */

/* Include files */
#include "sumMatrixIncludeNaN.h"
#include "MC_loop_parallel_types.h"
#include "rt_nonfinite.h"

/* Function Definitions */
real_T b_sumColumnB(const emxArray_real_T *x, int32_T col, int32_T vlen,
                    int32_T vstart)
{
  const real_T *x_data;
  real_T b_y;
  real_T y;
  int32_T b_k;
  int32_T i0;
  int32_T inb;
  int32_T k;
  int32_T nfb;
  x_data = x->data;
  if (vlen <= 1024) {
    i0 = vstart + (col - 1) * x->size[0];
    y = x_data[i0 - 1];
    for (k = 0; k <= vlen - 2; k++) {
      y += x_data[i0 + k];
    }
  } else {
    nfb = vlen / 1024;
    inb = nfb << 10;
    i0 = vstart + (col - 1) * x->size[0];
    y = x_data[i0 - 1];
    for (k = 0; k < 1023; k++) {
      y += x_data[i0 + k];
    }
    for (k = 2; k <= nfb; k++) {
      i0 = (vstart + ((k - 1) << 10)) + (col - 1) * x->size[0];
      b_y = x_data[i0 - 1];
      for (b_k = 0; b_k < 1023; b_k++) {
        b_y += x_data[i0 + b_k];
      }
      y += b_y;
    }
    if (vlen > inb) {
      i0 = (vstart + inb) + (col - 1) * x->size[0];
      b_y = x_data[i0 - 1];
      nfb = vlen - inb;
      for (k = 0; k <= nfb - 2; k++) {
        b_y += x_data[i0 + k];
      }
      y += b_y;
    }
  }
  return y;
}

real_T sumColumnB(const emxArray_real_T *x, int32_T col, int32_T vlen)
{
  const real_T *x_data;
  real_T b_y;
  real_T y;
  int32_T b_k;
  int32_T i0;
  int32_T inb;
  int32_T k;
  int32_T nfb;
  x_data = x->data;
  if (vlen <= 1024) {
    i0 = (col - 1) * x->size[0];
    y = x_data[i0];
    for (k = 0; k <= vlen - 2; k++) {
      y += x_data[(i0 + k) + 1];
    }
  } else {
    nfb = vlen / 1024;
    inb = nfb << 10;
    i0 = (col - 1) * x->size[0];
    y = x_data[i0];
    for (k = 0; k < 1023; k++) {
      y += x_data[(i0 + k) + 1];
    }
    for (k = 2; k <= nfb; k++) {
      i0 = ((k - 1) << 10) + (col - 1) * x->size[0];
      b_y = x_data[i0];
      for (b_k = 0; b_k < 1023; b_k++) {
        b_y += x_data[(i0 + b_k) + 1];
      }
      y += b_y;
    }
    if (vlen > inb) {
      i0 = (inb + (col - 1) * x->size[0]) + 1;
      b_y = x_data[i0 - 1];
      nfb = vlen - inb;
      for (k = 0; k <= nfb - 2; k++) {
        b_y += x_data[i0 + k];
      }
      y += b_y;
    }
  }
  return y;
}

real_T sumColumnB4(const emxArray_real_T *x, int32_T col, int32_T vstart)
{
  const real_T *x_data;
  real_T psum1;
  real_T psum2;
  real_T psum3;
  real_T psum4;
  int32_T i1;
  int32_T k;
  int32_T psum1_tmp;
  x_data = x->data;
  i1 = vstart + (col - 1) * x->size[0];
  psum1 = x_data[i1 - 1];
  psum2 = x_data[i1 + 1023];
  psum3 = x_data[i1 + 2047];
  psum4 = x_data[i1 + 3071];
  for (k = 0; k < 1023; k++) {
    psum1_tmp = i1 + k;
    psum1 += x_data[psum1_tmp];
    psum2 += x_data[psum1_tmp + 1024];
    psum3 += x_data[psum1_tmp + 2048];
    psum4 += x_data[psum1_tmp + 3072];
  }
  return (psum1 + psum2) + (psum3 + psum4);
}

/* End of code generation (sumMatrixIncludeNaN.c) */
