function [D,mu] = simulate_D(Delta,T,mubar,sigmaD,sigmamu,theta,burn)
%UNTITLED8 Summary of this function goes here
%   Detailed explanation goes here
dW = normrnd(0,1,T/Delta+burn,2); %Draw standard Wiener shocks, first column is dW_mu, second is dW_D
mu = zeros(T/Delta+burn,1); %Initialize mu vector
D = zeros(T/Delta+burn,1); %Initial D vector
mu(1)=mubar; %Starting value
D(1) = 1; %Starting value
for j=2:T/Delta+burn
    mu(j) = mu(j-1) + theta*(mubar-mu(j-1))*Delta + (sigmamu*Delta)*dW(j,1); %Update
    D(j) = D(j-1) + mu(j)*D(j-1)*Delta + (sigmaD*Delta)*D(j-1)*dW(j,2); %Update
end
D = D(burn+1:length(D)); %Discard burn periods
D = D./D(1); %Renormalize to start at 1
mu = mu(burn+1:length(mu)); %Discard burn periods
end

