function [W,bP,bI,bW] = solve_global_nomc(T,ff,nTrials,approx_flag,tol,max_its,w)
%UNTITLED12 Summary of this function goes here
%   Detailed explanation goes here

close all;
load params
iota_R=iota_R/ff;
iota_L=iota_L/ff;
% iota=0;
gamma=gamma_elas;
alpha=alpha_Ibar;
mu=mu_g;
sigma=sigma_D;




%% Create sparse grid

%Create a Smolyak sparse grid.  Uses Crenshaw-Curtis nested points, where w
%denotes the level of the sparse grid.
chebsize=0;
[S,Sr,n,domain,D_grid,m_grid,H_grid,Ibar_grid]...
    = grid_construct(w,chebsize);

%Solve for the equilibrium price function on the sparse grid and create a
%best linear approximation

V_grid=PV(m_grid,rho,mubar,theta,sigma_mu,sigma_m,D_grid);
W=zeros(1,n);
options = optimoptions('fsolve','SpecifyObjectiveGradient',true,'Display','off');
[P0,I0,flag] = Solve_Eq_Price_Global(V_grid,H_grid,gH,c,eta,chi,xm,gamma,Ibar_grid,fore_rate_BGP,W,n,V0,options);

Xgrid=[D_grid' m_grid' H_grid' Ibar_grid' ones(n,1)];
  
[bP,bI,~,R2] = ConstructApprox(P0,I0,Xgrid,S,Sr,domain,approx_flag);
P0_predict=Xgrid*bP;
scatter(P0_predict,P0);
        

%% Set up the Monto-Carlo simulation

dt=1/ff; %Simulation stepsize
nPeriods=T/dt; %Number of simulation periods
nBrowns=2;
bet=exp(-rho*dt); 
r=1/bet-1; %Implied interest rate

load Zsave;
if ~isequal(size(Z),[nPeriods,nBrowns,nTrials])
        Z=genZ(1,nBrowns,nPeriods,nTrials,dt);
        save('Zsave','Z');
end
%% Run the Monte-Carlo simulation

counter=1;
P0_old=P0;
dist=1;
fid=fopen('logMC.txt','w+');
n=uint16(n);

while dist>tol  && counter <= max_its
    tic
    W=MC_loop_noparallel(bP,bI,I0,P0,Xgrid,T,dt,alpha,aa,bb,iota_L,iota_R,sigma,...
            theta,mubar,K,r,LTV,n,nTrials,Z,fore_disc);
    time_of_MC=toc;
    [P0,I0,flag] = Solve_Eq_Price_Global(V_grid,H_grid,gH,c,eta,chi,xm,gamma,Ibar_grid,fore_rate_BGP,W,n,V0,options);
    [bP,bI,~,R2] = ConstructApprox(P0,I0,Xgrid,S,Sr,domain,approx_flag);
    dist=norm(P0-P0_old);
    fprintf(1,'Iteration %3d took %6.1f seconds \n',counter,time_of_MC);
    fprintf(1,'Iteration %3d distance norm equals %6.2e \n',counter,dist);
    fprintf(1,'Flag is %1i  \n',flag)
    P0_old=P0;
    counter = counter + 1;

end
bW=(Xgrid'*Xgrid)\(Xgrid'*W');
   






end

