%clear;
a = 0; 
b = 1; 
m = 50;
h = (b-a)/(m+1);
x = linspace(a,b,m+2);   % grid points x including boundaries
y = linspace(a,b,m+2);   % grid points y including boundaries
tol=1e-8;

[X,Y] = meshgrid(x,y);      % 2d arrays of x,y values
X = X';                     % transpose so that X(i,j),Y(i,j) are
Y = Y';                     % coordinates of (i,j) point

Iint = 2:m+1;              % indices of interior points in x
Jint = 2:m+1;              % indices of interior points in y
Xint = X(Iint,Jint);       % interior points
Yint = Y(Iint,Jint);

f = @(x,y) 1.25*exp(x+y/2);         % f(x,y) function
source = f(Xint,Yint);

utrue = exp(X+Y/2);   

usoln=zeros(m+2,m+2);
usoln(1,:)=exp(a+y/2);
usoln(m+2,:)=exp(b+y/2);
usoln(:,1)=exp(x+a/2);
usoln(:,m+2)=exp(x+b/2);

iter=1;
test=usoln(Iint,Jint)-1/4*(usoln(Iint+1,Jint)+usoln(Iint-1,Jint)...
    +usoln(Iint,Jint+1)+usoln(Iint,Jint-1)-h^2*source);
val=max(max(abs(test)));
usoln_old=usoln;
while val>tol 
usoln(Iint,Jint)=1/4*(usoln(Iint+1,Jint)+usoln(Iint-1,Jint)...
    +usoln(Iint,Jint+1)+usoln(Iint,Jint-1)-h^2*source);
test=usoln(Iint,Jint)-1/4*(usoln(Iint+1,Jint)+usoln(Iint-1,Jint)...
    +usoln(Iint,Jint+1)+usoln(Iint,Jint-1)-h^2*source);
val=max(max(abs(test)));
usoln_old=usoln;
iter=iter+1;
end

err = max(max(abs(usoln-utrue)));   
fprintf('Error relative to true solution of PDE = %10.3e \n',err)

max(max(abs(usoln-usoln2)))

surf(X,Y,usoln)
