 % collect SMM collects the output from SMM runs into a single matrix

% Figure out periods of simulations and number of parameters and blocks
load('smm_1/smm_block1.mat');
[pers nparams] = size(P_results_mat)
perblock = sum(P_results_mat(1,:)~=0)
nBlocks = ceil(nparams/perblock)

%initialize Matrices
P_mat = zeros(pers,nparams);
%Fore_rate_mat = zeros(pers,nparams);
%I_mat = zeros(pers,nparams);
%W_mat= zeros(pers,nparams);
%m_phi_mat = zeros(pers,nparams);
flags_mat = zeros(1,nparams);

eta_mat = zeros(1,nparams);
mu0_mat = zeros(1,nparams);
kappa_mat = zeros(1,nparams);
nu_mat = zeros(1,nparams);
k_mat = zeros(1,nparams);
phi_mat = zeros(1,nparams);
chi_mat = zeros(1,nparams);
iota_L_mat = zeros(1,nparams);
rho_mat = zeros(1,nparams);
aa_mat = zeros(1,nparams);
bb_mat = zeros(1,nparams);
gamma_elas_mat = zeros(1,nparams);

boomsize_mat = zeros(1,nparams);
bustsize_mat = zeros(1,nparams);
reboundsize_mat = zeros(1,nparams);
boomlength_mat = zeros(1,nparams);
bustlength_mat = zeros(1,nparams);
maxforeclosure_mat = zeros(1,nparams);
std_dP_bust_mat = zeros(1,nparams);
kurtosis_dP_bust_mat = zeros(1,nparams);
maxdprice_bust_mat = zeros(1,nparams);
maxdprice_rebound_mat = zeros(1,nparams);
yr9_negeq_mat = zeros(1,nparams);
yr9_10eq_mat = zeros(1,nparams);
yr9_20eq_mat = zeros(1,nparams);
bbrgrowth_mat = zeros(1,nparams);
expectation_2006_mat = zeros(1,nparams);
expectation_2019_mat = zeros(1,nparams);
m_phi_2006_mat = zeros(1,nparams);
m_phi_2019_mat = zeros(1,nparams);
boomconstruction_mat = zeros(1,nparams);
bustconstruction_mat = zeros(1,nparams);

% Loop over blocks
for blockNum = 1:nBlocks
    blockNum
    startnum = (blockNum-1)*perblock+1
    endnum = min(blockNum*perblock,nparams)
    
    try
        % Load Block Results
        load(strcat('smm_',string(blockNum),'/smm_block',string(blockNum),'.mat'));

        % Lot into outputing matrices
        P_mat(:,startnum:endnum)=P_results_mat(:,startnum:endnum);
        %Fore_rate_mat(:,startnum:endnum)=Fore_rate_results_mat(:,startnum:endnum);
        %I_mat(:,startnum:endnum)=I_results_mat(:,startnum:endnum);
        %W_mat(:,startnum:endnum)=W_results_mat(:,startnum:endnum);
        %m_phi_mat(:,startnum:endnum)=m_phi_results_mat(:,startnum:endnum);
        flags_mat(:,startnum:endnum)=flags_results_mat(:,startnum:endnum);

        eta_mat(:,startnum:endnum)=eta_results_mat(:,startnum:endnum);
        mu0_mat(:,startnum:endnum)=mu0_results_mat(:,startnum:endnum);
        kappa_mat(:,startnum:endnum)=kappa_results_mat(:,startnum:endnum);
        nu_mat(:,startnum:endnum)=nu_results_mat(:,startnum:endnum);
        k_mat(:,startnum:endnum)=k_results_mat(:,startnum:endnum);
        phi_mat(:,startnum:endnum)=phi_results_mat(:,startnum:endnum);
        chi_mat(:,startnum:endnum)=chi_results_mat(:,startnum:endnum);
        iota_L_mat(:,startnum:endnum)=iota_L_results_mat(:,startnum:endnum);
        rho_mat(:,startnum:endnum)=rho_results_mat(:,startnum:endnum);
        aa_mat(:,startnum:endnum)=aa_results_mat(:,startnum:endnum);
        bb_mat(:,startnum:endnum)=bb_results_mat(:,startnum:endnum);
        gamma_elas_mat(:,startnum:endnum)=gamma_elas_results_mat(:,startnum:endnum);

        boomsize_mat(:,startnum:endnum)=boomsize_results_mat(:,startnum:endnum);
        bustsize_mat(:,startnum:endnum)=bustsize_results_mat(:,startnum:endnum);
        reboundsize_mat(:,startnum:endnum)=reboundsize_results_mat(:,startnum:endnum);
        boomlength_mat(:,startnum:endnum)=boomlength_results_mat(:,startnum:endnum);
        bustlength_mat(:,startnum:endnum)=bustlength_results_mat(:,startnum:endnum);
        maxforeclosure_mat(:,startnum:endnum)=maxforeclosure_results_mat(:,startnum:endnum);
        std_dP_bust_mat(:,startnum:endnum)=std_dP_bust_results_mat(:,startnum:endnum);
        kurtosis_dP_bust_mat(:,startnum:endnum)=kurtosis_dP_bust_results_mat(:,startnum:endnum);
        maxdprice_bust_mat(:,startnum:endnum)=maxdprice_bust_results_mat(:,startnum:endnum);
        maxdprice_rebound_mat(:,startnum:endnum)=maxdprice_rebound_results_mat(:,startnum:endnum);
        yr9_negeq_mat(:,startnum:endnum)=yr9_negeq_results_mat(:,startnum:endnum);
        yr9_10eq_mat(:,startnum:endnum)=yr9_10eq_results_mat(:,startnum:endnum);
        yr9_20eq_mat(:,startnum:endnum)=yr9_20eq_results_mat(:,startnum:endnum);
        bbrgrowth_mat(:,startnum:endnum)=bbrgrowth_results_mat(:,startnum:endnum);
        expectation_2006_mat(:,startnum:endnum)=expectation_2006_results_mat(:,startnum:endnum);
        expectation_2019_mat(:,startnum:endnum)=expectation_2019_results_mat(:,startnum:endnum);
        m_phi_2006_mat(:,startnum:endnum)=m_phi_2006_results_mat(:,startnum:endnum);
        m_phi_2019_mat(:,startnum:endnum)=m_phi_2019_results_mat(:,startnum:endnum);
        boomconstruction_mat(:,startnum:endnum)=boomconstruction_results_mat(:,startnum:endnum);
        bustconstruction_mat(:,startnum:endnum)=bustconstruction_results_mat(:,startnum:endnum);
    catch
    end
end

save('smm_combined.mat','P_mat',... %'Fore_rate_mat','I_mat','m_phi_mat','W_mat',...
    'flags_mat','eta_mat','mu0_mat','kappa_mat',...
    'nu_mat','k_mat','phi_mat','chi_mat','iota_L_mat',...
    'rho_mat','aa_mat','bb_mat','gamma_elas_mat',...
    'boomsize_mat','bustsize_mat','reboundsize_mat','boomlength_mat',...
    'bustlength_mat','maxforeclosure_mat','std_dP_bust_mat',...
    'kurtosis_dP_bust_mat','maxdprice_bust_mat','maxdprice_rebound_mat',...
    'yr9_negeq_mat','yr9_10eq_mat','yr9_20eq_mat',...
    'bbrgrowth_mat','expectation_2006_mat','expectation_2019_mat',...
    'm_phi_2006_mat','m_phi_2019_mat',...
    'boomconstruction_mat','bustconstruction_mat','-v7.3');
